<?php 

    session_start(); //iniciamos session    
    error_reporting(0); //eliminamos notificación de errores
    define('DOMINIO', 'salud.dga.es'); //crea el valor de la constante del dominio
    define('DN', 'dc=salud,dc=dga,dc=es'); //crea el valor de la constante de DN


function identifica($user,$pass)
{ 

     $usuario = trim($user).'@'.DOMINIO;  //variable usuario
     $contrasena = trim($pass);  //variable contraseña
     $ds = DOMINIO;  //variable dominio
     $dn = DN;      //variable DN
     $puertoldap = 389;  //variable puerto
     $conectar = ldap_connect($ds,$puertoldap);     //asigna a variable la CONEXIÓN LDAP
       ldap_set_option($conectar, LDAP_OPT_PROTOCOL_VERSION,3);  //confirma la versión del protocolo
       ldap_set_option($conectar, LDAP_OPT_REFERRALS,0);    //no muestra errores en el servidor
       $autenticado = @ldap_bind($conectar, $usuario, $contrasena);  //Realiza la autenticación con un servidor LDAP
       
       if ($autenticado)
       { //Si la autenticacion ha sido correcta
         
             $filtro="(|(SAMAccountName=".trim($user)."))"; //Filtra el usuario por el campo SAMAccountName
             $atributos = array("displayname","mail","samaccountname","givenname","cn","objectsid"); //Crea un array con todos los atributos de Active Directory del usuario
             $busqueda = @ldap_search($conectar, $dn, $filtro, $atributos);  //Buscar el árbol LDAP
             $info = @ldap_get_entries($conectar, $busqueda);  //Obtener todas las entradas de los resultados
             
             $NIF = $info[0]["cn"][0];  //Asignamos a la variable NIF
             $NOMBRE = $info[0]["displayname"][0];        //Asignamos a la variable NOMBRE
             $_SESSION['NIF'] = $NIF;           //Creamos sesion para pasar la variable NIF
             $_SESSION['NOMBRE'] = $NOMBRE;     //Creamos sesion para pasar la variable NOMBRE

            
       }
       else
       {  
             $atributos=0;      //Si no encuentra nada devuelve 0
       }  
                                
     ldap_close($conectar);     //Cerramos conexión ldap
     return $atributos;     //Devuelve el valor de atributos. Si es distinto a 0 deja continuar
}  

?>